<?

/*
      index.php f&uuml;r PHP Magazin Demos Backend
      
      Aufgabe:
      	Startseite
      
		Benutzte Variablen:
			Aufruf:
           aktion   ggf. durchzuf&uuml;hrende Aktion
           id       ggf. ID, f&uuml;r die die Aktion gilt
           titel    ggf. einzutragender Titel
           text     ggf. einzutragender Text
           benutzer ggf. der einzuloggende Benutzer
           passwort ggf. dessen Passwort
						
 */

// Session starten
session_start();

// Include-Datei f&uuml;r die Konfigurationsdaten
require("../lib/config.inc");

require("../lib/sicherheit.inc");
   // verschiedenen Sicherheits-Funktionen

if ($_REQUEST["aktion"] == "ausloggen") {
   if (testeGETToken("ausloggen")) {
      // (Wahrscheinlich) kein CSRF-Angriff, Benutzer eintragen
      // L&ouml;schen aller Session-Variablen.
      $_SESSION = array();

      // Session-Cookie l&ouml;schen
      if (ini_get("session.use_cookies")) {
          $params = session_get_cookie_params();
          setcookie(session_name(), '', time() - 42000, $params["path"], $params["domain"], $params["secure"], $params["httponly"]);
      }
      // L&ouml;schen der Session
      session_destroy();
      $ausgeloggt = true;
   } else {
      // Mglicher CSRF-Angriff erkannt! 
      $ausgeloggt = false;
   }
}

// Datei mit den Sprachanpassungen einbinden
switch($_REQUEST["sprache"]) {
   case "de":
      include("../lib/sprache/de.inc");
      $getsprache = "sprache=de";
      $postsprache = "<input type=\"hidden\" name=\"sprache\" value=\"de\">  \n";
      $diesprache = "de";
   break;
   case "en":
      include("../lib/sprache/en.inc");
      $getsprache = "sprache=en";
      $postsprache = "<input type=\"hidden\" name=\"sprache\" value=\"en\">  \n";
      $diesprache = "en";
  break;
   default:
      include("../lib/sprache/".DEFAULTSPRACHE.".inc");
      $getsprache = "";
      $postsprache =  "";
      $diesprache = "nichts ausgew&auml;hlt";
   break;
}


// Parameter &uuml;bernehmen:
$aktion   = $_REQUEST["aktion"];
$id       = (int) $_REQUEST["id"];
$titel    = htmlentities(strip_tags($_POST["titel"]));
$text     = strip_tags($_POST["text"], "<a><img><pre><p><b>");
$benutzer = $_REQUEST["benutzer"];
$passwort = $_REQUEST["passwort"];
$plugin   = $_REQUEST["plugin"];

// Variablen initialisieren
$ergebnis   = "";              // nimmt Fehlermeldungen etc. auf
$dbok       = false;           // noch gibt es keine Verbindung zur Datenbank
$eingeloggt = false;           // noch ist kein Benutzer eingeloggt

// Konstante definieren
define("IMBACKEND", "TRUE");

// Verbindung zur Datenbank herstellen: Ohne DB geht nichts
$connection = mysql_connect(HOSTNAME,USERNAME,PASSWORD);
if (!$connection) {
   // Keine Verbindung zu MySQL
	$ergebnis = $ergebnis."<br>Fehler bei der Verbindung mit MySQL: <br> \n MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
   $dbok = false;
} else {
   $test = mysql_select_db(DATENBANK);
   if (!$test) {
      // Keine Verbindung zur Datenbank
      $ergebnis =  $ergebnis."<br>Fehler bei der Verbindung mit der Datenbank: <br> \n MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
      $dbok = false;
   } else {
      $dbok = true;
	}
}

if ($dbok) {
   // Verbindung mit der Datenbank steht
   if ($aktion == "einloggen") {
      // Der Benutzer m&ouml;chte sich einloggen
   
      // Wenn magic_quotes_gpc aktiv ist, m&uuml;ssen die eingef&uuml;gten Backslash entfernt werden:
      if (get_magic_quotes_gpc()) {
         $benutzer = stripslashes($benutzer);
         $passwort = stripslashes($passwort);
      }
      // SQL-Sonderzeichen maskieren, dies ist erst nach der Verbindung mit der DB m&ouml;glich
      $benutzer =  mysql_real_escape_string($benutzer);
      $passwort =  mysql_real_escape_string($passwort);

      // Nachsehen, ob es die Kombination von Benutzername und Passwort gibt
      $query = "SELECT Benutzer_ID, istAutor, freigegeben FROM benutzer_tabelle WHERE (Benutzer_Name = '".$benutzer."') AND (Passwort = '".$passwort."')";
      $result = mysql_query($query);
      if (!$result) {
         // Fehler beim Holen des Eintrags:
         $ergebnis = $ergebnis."Fehler bei der Abfrage der Zugangsdaten: <br> \n MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
         $eingeloggt = false;
      } else {
         $row = mysql_fetch_array($result);
         if ($row["freigegeben"] == 1 ) {
             // Anmeldung erfolgreich, der Benutzer ist freigegeben
             if ($row["istAutor"] == 1) {
                 // Status OK, Benutzer akzeptiert
                 $_SESSION["PHPMagUserID"] = $row["Benutzer_ID"];
                 $_SESSION["PHPMagStatus"] = $row["istAutor"];
                 $_SESSION["eingeloggt"] = true;
                 $eingeloggt = true;
             } else {
                 // Zwar Benutzer, aber kein Autor => Pech gehabt
                 $ergebnis = $ergebnis."<b>Sie sind nur Benutzer, kein Autor!</b> <br> \n";
                 $eingeloggt = false;
             }                                                       
         } else {
             $ergebnis = $ergebnis."<b>Authentifizierung fehlgeschlagen!</b> <br> \n";
             $eingeloggt = false;
         }
	   }
   } elseif ($aktion == "ausloggen") {
      // Der Benutzer m&ouml;chte sich ausloggen
      // Das eigentlich Ausloggen ist oben bereits passiert (damit der Session-Cookie gelscht werden kann)
      if ($ausgeloggt) {
          $ergebnis = $ergebnis."<b>Ausloggen war erfolgreich</b> <br> \n";
          $eingeloggt = false;
      } 
      else {
          $ergebnis = $ergebnis."<b>Fehler beim Ausloggen</b> <br> \n";
          $eingeloggt = true;
      }           
   } else {   
       // wenn sich der Benutzer weder ein- noch ausloggen will, ist er wohl schon eingeloggt
       $BenutzerID = $_SESSION["PHPMagUserID"];
       $BenutzerStatus = $_SESSION["PHPMagStatus"];
       if ( ($BenutzerID >= 0) AND ($BenutzerStatus == 1) ) {
          // Cookies vorhanden und Status OK, prima
          // Jetzt fehlt nur noch der Benutzername, nur der Vollst&auml;ndigkeit halber
          $query = "SELECT Benutzer_Name FROM benutzer_tabelle WHERE Benutzer_ID = ".$BenutzerID;
          $result = mysql_query($query);
          if (!$result) {
             // Fehler beim Holen des Eintrags, aber da das nur ein Sch&ouml;nheitsfehler ist, kann er ignoriert werden
          } else {
             $row = mysql_fetch_array($result);
             $benutzer = $row["Benutzer_Name"];
          }          
          $eingeloggt = true;
       } else {
          $eingeloggt = false;
       }
   }
} else {
   // keine Verbindung mit der Datenbank
   $eingeloggt = false;
}


?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>PHP Magazin Demos - Backend</title>
</head>

<body>

<h1>PHP Magazin Demos - Backend</h1>

<p>
Zum <a href="../admin/index.php?<? echo $getsprache; ?>">Administrationsbereich</a>,
zur <a href="../index.php?<? echo $getsprache; ?>">Startseite</a>
oder zum <a href="index.php?aktion=plugin2&<? echo $getsprache; ?>">weitergeleiteten</a> Backend-Plugin .
</p>

<hr>

<p> 
Dieses Skript ist vor allem am Anfang ziemlich beschr&auml;nkt: Es
k&ouml;nnen Daten in der Datenbank gespeichert werden, es k&ouml;nnen alle
Eintr&auml;ge als Titelliste angezeigt werden, und einzelne Eintr&auml;ge
k&ouml;nnen komplett wieder ausgeben oder gel&ouml;scht werden.
</p>

<p> 
Bisher wird dabei nur zwischen Autoren und Benutzern unterschieden: Nur
Autoren haben Zugriff auf das Backend, aber dort sind sie gleichberechtigt,
d.h. jeder Autor kann alle Texte l&ouml;schen. 
</p>

<hr>

<?

echo "Ausgew&auml;hlte Sprachdatei: ".$diesprache."<br> \n";


if ($eingeloggt) {
   echo "<p> \n Sie sind eingeloggt als Benutzer \"<b>$benutzer</b>\".\n";
   echo "(<a href=\"index.php?aktion=ausloggen&token=".erzeugeToken("ausloggen")."&".$getsprache."\">Ausloggen</a>) \n </p> \n <hr> \n";

   switch ($aktion) {
   case "anzeigen":
      // anzeige des Texts mit der ID $id
      $query = "SELECT Titel, Angelegt, Text, AutorID FROM text_tabelle WHERE Text_ID = ".$id; 
      $result = mysql_query($query);
      if (!$result) {
         // Fehler beim Holen des Eintrags:
         echo "Fehler beim Holen des Texts:<br> \n";
         echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
      } else {
         $row = mysql_fetch_array($result);

         // Jetzt fehlt nur noch der Autorenname...
         $autorquery = "SELECT Benutzer_Name FROM benutzer_tabelle WHERE Benutzer_ID = ".$row["AutorID"];
         $autorresult = mysql_query($autorquery);
         if (!$result) {
            // Fehler beim Holen des Eintrags, aber da das nur ein Sch&ouml;nheitsfehler ist, kann er ignoriert werden
            $autor = "";
         } else {
            $autorrow = mysql_fetch_array($autorresult);
            $autor = $autorrow["Benutzer_Name"];
         }    
  
         echo "<h2>Der Eintrag:</h2>";
         echo "<table width=\"80%\" border=\"2\" cellspacing=\"2\" cellpadding=\"2\"> \n ";
         echo "<tr> \n";
         echo "<td> ".$row["Titel"]." </td> \n";
         echo "<td> ".$autor." </td> \n";
         echo "<td> ".$row["Angelegt"]." </td> \n";
         echo "</tr> \n";
         echo "<tr> \n";
         echo "<td colspan=\"3\"> ".$row["Text"]." </td> \n";
         echo "</tr> \n";
         echo "</table> <br> \n";
         echo "<form action=\"index.php\" method=\"POST\"> \n";
         echo $postsprache;
         echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("loeschen")."\"> \n";
         echo "<input type=\"hidden\" name=\"id\" value=\"".$id."\"> \n";
         echo "<input type=\"submit\" name=\"aktion\" value=\"loeschen\"> \n";
         echo "</form> \n";
	   }
   break;
   case "eintragen":
      // Daten eintragen
      if (testeToken("neuerText")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Text eintragen

          // Wenn magic_quotes_gpc aktiv ist, m&uuml;ssen die eingef&uuml;gten Backslash entfernt werden:
          if (get_magic_quotes_gpc()) {
             $titel = stripslashes($titel);
             $text  = stripslashes($text);
          }

          // SQL-Sonderzeichen maskieren, dies ist erst nach der Verbindung mit der DB m&ouml;glich
          $titel =  mysql_real_escape_string($titel);
          $text  =  mysql_real_escape_string($text);

          $query = "INSERT INTO text_tabelle (Titel, Text, AutorID)
                                values ('$titel', '$text', $BenutzerID)";
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo "Fehler beim Eintragen des neuen Texts:<br> \n";
             echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo "<b>Text erfolgreich eingetragen!</b> <br> \n";
          }
      } else {
          echo $err_csrf;
      }
   break;
   case "loeschen":
      // Eintrag l&ouml;schen
      if (testeToken("loeschen")) {
          // (Wahrscheinlich) kein CSRF-Angriff, Text lschen
          $query = "DELETE FROM text_tabelle WHERE Text_ID=".$id;   
          if (!mysql_query($query)) {
             // MySQL-Fehler
             echo "Fehler beim L&ouml;schen des Texts:<br> \n";
             echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
          } else {
             echo "<b>Text erfolgreich gel&ouml;scht!</b> <br> \n";
          }
      } else {
          echo $err_csrf;
      }
   break;
   case "plugin2":
      // es wird das Plugin aufgerufen
      echo "<script>location.href = \"plugins/plugin2.php\";</script> \n";
   break;
	default:
   break;
   }

   // ggf. Plugin einbinden
   // zuerst festellen, welche Plugins es gibt:
   $dir = array();
   $alleplugins = array();
   $dir = scandir("plugins/");
   foreach ($dir as $filename) {
      $pfadinfo = pathinfo(dirname(__FILE__)."/plugins/".$filename);
      if (is_file(dirname(__FILE__)."/plugins/".$filename)) {
         // Dateien rauspicken
         if ($pfadinfo["extension"] == "php") {
            // Dateien mit Endung .php rauspicken
            $alleplugins[] = basename($filename, ".php");
                             // ab PHP 5.2.0 geht auch $pfadinfo["filename"]
         }         
      }
   } 
   // $alleplugins enthlt jetzt die vorhandenen Plugins
   if (isset($_REQUEST["plugin"])) {
      // Es ist ein Plugin ausgewhlt
      if (in_array($_REQUEST["plugin"], $alleplugins)) {
         // Das Plugin gibt es, es kann eingebunden werden
         include("plugins/".$_REQUEST["plugin"].".php");
	   }
	    else {
	      // da wollte wohl jemand manipulieren...
	   }
	}
	 else {
	    // kein Plugin einbinden
	}

   echo "<hr> \n <h2>Die bisherigen Eintr&auml;ge</h2> \n";
   echo "<p> \n";
   // Einfach ohne R&uuml;cksicht auf Verluste alle Titel ausgeben
   $query = "SELECT * FROM text_tabelle ORDER BY Angelegt"; 
   $result = mysql_query($query);
   if (!$result) {
      // Fehler beim Ergebnis
      echo "<br>Fehler beim Holen der Texte:<br> \n";
      echo "MySQL-Fehler: ".mysql_errno().": ".mysql_error()."<br> \n";
   } else {
      // Jetzt kann es losgehen...
      while ($row = mysql_fetch_array($result)) {
         echo $row["Angelegt"]." : ";
         echo "<!-- ID: ".$row["Text_ID"]." -->  ";
         echo "<a href=\"index.php?aktion=anzeigen&id=".$row["Text_ID"]."&".$getsprache."\">".$row["Titel"]."</a>\n";
         echo "<br><br> \n";
      }  
   }
   
   echo "<hr> \n <h2>Neuen Eintrag eingeben:</h2> \n\n";
   echo "<p>\n Autor: <b>$benutzer</b></p>\n";
   echo "<form action=\"index.php\" method=\"POST\"> \n"; 
   echo $postsprache;
   echo "<input type=\"hidden\" name=\"token\" value=\"".erzeugeToken("neuerText")."\"> \n";
   echo "   <input type=\"text\" name=\"titel\" value=\"Der Titel\" size=\"80\" maxlength=\"250\"> \n";
   echo "   <br><br>  \n";
   echo "   <textarea rows=\"10\" cols=\"80\" name=\"text\">Der Text</textarea> \n";
   echo "   <br><br> \n";
   echo "   <input type=\"submit\" name=\"aktion\" value=\"eintragen\"> \n";
   echo "</form> \n\n";
      
   } else {
       // Keine Verbindung mit der Datenbank oder Fehler beim Einloggen
       echo $ergebnis;
       echo "<b>Bitte loggen Sie sich ein!</b> <br> \n";
       echo "\n\n <hr> \n\n";
       echo "<h2>Als Autor einloggen:</h2> \n";
       echo "<form action=\"index.php\" method=\"POST\"> \n";
       echo $postsprache;
       echo "Benutzername:<br> \n";
       echo "<input type=\"text\" name=\"benutzer\" value=\"autor\" size=\"20\" maxlength=\"50\"> <br> \n";
       echo "Passwort: <br> \n";
       echo "<input type=\"text\" name=\"passwort\" value=\"autor\" size=\"20\" maxlength=\"50\"> <br>\n";
       echo "<input type=\"submit\" name=\"aktion\" value=\"einloggen\"> \n";
       echo "</form> \n";
}


?>   


</body>
</html>
