<?

/*
      index.php f&uuml;r Datei-Tests
      
      Aufgabe:
      	Demonstration der Funktionen zum Pr&uuml;fen von Dateinamen und Pfaden
      
		Benutzte Variablen:
			Aufruf:
           dateiname   der zu pr&uuml;fende Dateinanme				

 */

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>PHP Magazin Demos - Datei-Funktionen</title>
</head>

<body>

<h1>PHP Magazin Demos - Datei-Funktionen</h1>

<p>
Hier k&ouml;nnen Sie mit den Funktionen zum Pr&uuml;fen von Dateinamen und Pfaden experimentieren.
</p>


<p>
Die Eingabe muss relativ zum aktuellen Verzeichnis <? echo dirname(__FILE__); ?> sein.
</p>

<p>
M&ouml;gliche Eingaben sind z.B. ?dateiname=
</p>

<ul>
   <li> test.txt
   <li> test.txt%00.jpg
   <li> test.txt%00.gif
   <li> test.jpg%00.txt
   <li> gibt/es/nicht/../../../index.php
   <li> ../../../../../../../etc/passwd
   <li> http://www.ceilers-it.de/phpmag/610.txt
   <li> ftp://ftp.apple.com/Apple_Support_Area/REDIRECT.txt
</ul>

<p>
F&uuml;gen Sie einfach den gew&uuml;nschten Parameter in der URL-Zeile
ein und vergleichen Sie die verschiedenen Ergebnisse.
</p>

<p>
Folgende Dateien sind im Verzeichnis vorhanden:
</p>

<pre><code>index.php
test.jpg
test.jpg.txt
test.txt.jpg
test.txt</code></pre>

<p>
Ist es nicht seltsam,
dass z.B. die Datei <code>gibt/es/nicht/../../../index.php</code> gelesen werden
kann, obwohl ihr "realpath" gar nicht existiert?<br>
Oder das eine nicht vorhandene Datei wie <code>test.txt.gif</code> angeblich 
existiert (wenn man nach <code>test.txt%00.gif</code> fragt)?
</p>



<hr>


<hr>

<?

if (isset($_GET["dateiname"])) {
   $realpfad     = realpath($_GET["dateiname"]);
   $pfadinfoein  = pathinfo($_GET["dateiname"]);
   $pfadinforeal = pathinfo($realpfad);

   echo "<table> \n";
   echo "   <tr> \n";
   echo "      <td>  </td> \n";
   echo "      <td> mit Eingabewert </td> \n";
   echo "      <td> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td> \n";
   echo "      <td> mit realpath(Eingabewert) </td> \n";
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td> Ausgangswert: </td> \n";
   echo "      <td>".$_GET["dateiname"]."</td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>".$realpfad."</td> \n";
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td> is_file():  </td> \n";
   echo "      <td>";
   if (is_file($_GET["dateiname"])) {
       echo " ja </td> \n";
   } else {
       echo " nein </td> \n";
   }   
   echo "      <td>  </td> \n";
   echo "      <td>";
   if (is_file($realpfad)) {
       echo " ja </td> \n";
   } else {
       echo " nein </td> \n";
   }   
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td> file_exists():  </td> \n";
   echo "      <td>";
   if (file_exists($_GET["dateiname"])) {
       echo " ja </td> \n";
   } else {
       echo " nein </td> \n";
   }   
   echo "      <td>  </td> \n";
   echo "      <td>";
   if (file_exists($realpfad)) {
       echo " ja </td> \n";
   } else {
       echo " nein </td> \n";
   }   
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td>  </td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>  </td> \n";
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td> pathinfo 'dirname': </td> \n";
   echo "      <td>".$pfadinfoein["dirname"]."</td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>".$pfadinforeal["dirname"]."</td> \n";
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td> pathinfo 'basename': </td> \n";
   echo "      <td>".$pfadinfoein["basename"]."</td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>".$pfadinforeal["basename"]."</td> \n";
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td> pathinfo 'extension': </td> \n";
   echo "      <td>".$pfadinfoein["extension"]."</td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>".$pfadinforeal["extension"]."</td> \n";
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td> pathinfo 'filename' (ab PHP 5.2.0): </td> \n";
   echo "      <td>".$pfadinfoein["filename"]."</td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>".$pfadinforeal["filename"]."</td> \n";
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td>  </td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>  </td> \n";
   echo "   </tr> \n";
   echo "   <tr> \n";
   echo "      <td> basename:  </td> \n";
   echo "      <td>".basename($_GET["dateiname"])."</td> \n";
   echo "      <td>  </td> \n";
   echo "      <td>".basename($realpfad)."</td> \n";
   echo "   </tr> \n";
   echo "</table> \n";

   echo "<hr> \n";

   echo "<p>Der Dateiinhalt aus der Eingabe - <code>file_get_contents(".$_GET["dateiname"].")</code>: </p> \n <pre>";
   echo htmlentities(file_get_contents($_GET["dateiname"]));
   echo "</pre> \n";

   echo "<hr> \n";

   echo "<p>Der Dateiinhalt aus dem realpath(Eingabe) - <code>file_get_contents(".$realpfad.")</code>: </p> \n <pre>";
   echo htmlentities(file_get_contents($realpfad));
   echo "</pre> \n";

   echo "<hr> \n";

}

?>



</body>
</html>